//================================================================================
// MapVoteListBox.
//================================================================================
class MapVoteListBox extends UWindowListBox;
//
#exec texture IMPORT NAME=boxbg File=Textures\boxbg1.pcx GROUP=Mapvote MIPS=OFF

var string ThisGame;
var string sGameNum;
var string sMapPref;
var bool   bBold;
var int    VScrol;

function Paint (Canvas C, float MouseX, float MouseY)
{
	C.DrawColor.R=255;
	C.DrawColor.G=255;
	C.DrawColor.B=255;

    if (sGameNum != "1")
        DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'boxbg');
    Super.Paint(C,MouseX,MouseY);
}

function DrawItem (Canvas C, UWindowList Item, float X, float Y, float W, float H)
{
	local string MapName;
	local string CapMapName;
	local bool bSelected;
	local int iRes;

    MapName = MapVoteUMenuList(Item).MapName;

    if (Caps(ThisGame) == Caps(Mid(Mapname, 3)) && sGameNum == "1")
        return;

	if ( MapVoteUMenuList(Item).bSelected )
	{
		C.DrawColor.R=0;
		C.DrawColor.G=0;
		C.DrawColor.B=128;
		if (Caps(ThisGame) == Caps(Mid(Mapname, 3)))
		{
  		    C.DrawColor.R=64;
		    C.DrawColor.G=64;
		    C.DrawColor.B=64;
		}
		else
		if ( Left(MapName,3) == "[X]" )
		{
  		    C.DrawColor.R=160;
		    C.DrawColor.G=160;
		    C.DrawColor.B=160;
		}
		DrawStretchedTexture(C,X,Y,W,H - 1,Texture'boxbg');
		bSelected = True;
	}
	else
	{
		C.DrawColor.R=255;
		C.DrawColor.G=255;
		C.DrawColor.B=255;
	    DrawStretchedTexture(C,X,Y,W,H - 1,Texture'boxbg');
		bSelected=False;
	}

	C.Font = Root.Fonts[0];
	if (bBold)
	    C.Font = Root.Fonts[1];

	if ( Left(MapName,3) == "[X]" )
	{
		C.DrawColor.R=200;
		C.DrawColor.G=0;
		C.DrawColor.B=0;
		ClipText(C,X + 2,Y,Mid(MapName,3));
	}
	else
	{
	    if ( bSelected )
	    {
		    C.DrawColor.R=255;
		    C.DrawColor.G=255;
		    C.DrawColor.B=255;
	    }
	    else
	    {
 	        C.DrawColor.R=1;
			C.DrawColor.G=1;
			C.DrawColor.B=1;
        }
        if (Left(MapName,3) == "[G]")
        {
            MapName = Mid(MapName, 3);
            if (Caps(ThisGame) == Caps(Mapname) && !MapVoteUMenuList(Item).bSelected)
            {
		       C.DrawColor.R=80;
		       C.DrawColor.G=80;
		       C.DrawColor.B=80;
		    }
		}
		ClipText(C,X + 2,Y,MapName);
	}
}

// 48=0 49-57 = 1-9 / 65-90 = a-z
function KeyDown (int Key, float X, float Y)
{
	local int i;
	local UWindowListBoxItem ItemPointer;
	local MapVoteUMenuList MapItem;
	local PlayerPawn P;
	local string sTemp;

	P=GetPlayerOwner();

	if (Key == P.EInputKey.IK_MouseWheelDown || Key == P.EInputKey.IK_Down)
	{
		if ( (SelectedItem != None) && (SelectedItem.Next != None) )
		{
			SetSelectedItem(UWindowListBoxItem(SelectedItem.Next));
			MakeSelectedVisible();
		}
	}
	if (Key == P.EInputKey.IK_MouseWheelUp || Key == P.EInputKey.IK_Up)
	{
		if ( (SelectedItem != None) && (SelectedItem.Prev != None) && (SelectedItem.Sentinel != SelectedItem.Prev) )
		{
			SetSelectedItem(UWindowListBoxItem(SelectedItem.Prev));
			MakeSelectedVisible();
		}
	}
	if (Key == P.EInputKey.IK_PageDown)
	{
		if ( SelectedItem != None )
		{
			ItemPointer = SelectedItem;
            for (i=0; i<VScrol; i++)
            {
                if (ItemPointer.Next == None)
                    break;
                   //return;
                ItemPointer = UWindowListBoxItem(ItemPointer.Next);
            }
			SetSelectedItem(ItemPointer);
			MakeSelectedVisible();
		}
	}
	if (Key == P.EInputKey.IK_PageUp)
	{
		if ( SelectedItem != None )
		{
			ItemPointer=SelectedItem;
            for(i=0; i<VScrol; i++)
            {
                if (ItemPointer.Prev == None || ItemPointer.Prev == SelectedItem.Sentinel)
                    break;
                   //return;
                ItemPointer = UWindowListBoxItem(ItemPointer.Prev);
            }
			SetSelectedItem(ItemPointer);
			MakeSelectedVisible();
		}
	}
	if (sMapPref != "")
	{
	   if ((Key > 47 && Key < 58) || (Key > 64 && Key < 91))
	   {
	      sTemp = sMapPref$"-"$chr(Key);
	      //Log("KeyDown - Key = "$Key$" | sTemp = "$sTemp);
	      Find(sTemp);
	   }
	}

	ParentWindow.KeyDown(Key,X,Y);
}

function SelectMap(string MapName)
{
   local string sTemp;
   local MapVoteUMenuList MapItem;

   for (MapItem = MapVoteUMenuList(Items); MapItem != None; MapItem = MapVoteUMenuList(MapItem.Next) )
   {
      sTemp = MapItem.MapName;
      if (Left(sTemp, 3) == "[G]")
         sTemp = Mid(sTemp, 3);
      if (MapName ~= sTemp)
      {
         SetSelectedItem(MapItem);
         MakeSelectedVisible();
         break;
      }
   }
}

function bool isItemInList (string MapName)
{
	local MapVoteUMenuList MapItem;

    for ( MapItem = MapVoteUMenuList(Items); MapItem != None; MapItem = MapVoteUMenuList(MapItem.Next))
    {
		if ( MapName ~= MapItem.MapName )
		{
			return True;
		}
    }
	return False;
}

function DoubleClickItem (UWindowListBoxItem i)
{
	UWindowDialogClientWindow(ParentWindow).Notify(self, 11);
}

function Find(string SearchText)
{
   local int i;
   local UWindowListBoxItem ItemPointer;
   local MapVoteUMenuList MapItem;

   for (MapItem = MapVoteUMenuList(Items); MapItem != None; MapItem = MapVoteUMenuList(MapItem.Next) )
   {
      if (Caps(SearchText) <= Caps(left(MapItem.MapName,len(SearchText))))
      {
         SetSelectedItem(MapItem);
         MakeSelectedVisible();
         break;
      }
   }
}

//

defaultproperties
{
    ItemHeight=12.00
    ListClass=Class'MapVoteUMenuList'
}
