//================================================================================
// MapVoteRepeatLimits
//================================================================================

class MapVoteRepeatLimits extends Info config(MapVoteX);
//
var MapVoteX MyMut;

var int  RepeatLimit;

struct MapRepeats
{
    var() string Maps;
};

var() config bool  bAdjustIndividualGames;
var() config MapRepeats GameMapLimits[30];

function AddMap(int GameNum, string MapName)
{
    local string sTemp;
	local int i, j;

	if ( MapName == "" || Left(MapName, 3) == "[G]" || RepeatLimit < 1 )
	{
		return;                                 // do not allow games
	}

    MapName = Caps(MapName);
    sTemp = Caps(GameMapLimits[GameNum].Maps);
    j = InStr(sTemp, MapName);
    if (j < 0)
    {
       sTemp = sTemp$MapName$":"$RepeatLimit$",";
       GameMapLimits[GameNum].Maps = sTemp;
       SaveConfig();
    }
}

function AdjustMapRepeats(int GameNum)          // gamenum not used atm
{
    local string sTemp, sMap, NewMaps;
	local int i, j, k, l;

    if (RepeatLimit < 1)
        return;

    for (i=0; i<30; i++)
    {
        if (bAdjustIndividualGames)
           i = GameNum;
        if (GameMapLimits[i].Maps != "")
        {
           NewMaps = "";
           sTemp = Caps(GameMapLimits[i].Maps); // incase admin added some
           if (Right(sTemp, 1) != ",")
               sTemp = sTemp$",";
           for (j=0; j<100; j++)
           {
               k = InStr(sTemp, ",");
               if (k == -1)
                  break;
               sMap = Left(sTemp, k);
               sTemp = Mid(sTemp, k+1);
               k = InStr(sMap, ":");
               l = int(Mid(sMap, k+1));
               sMap = Left(sMap,k);
               if (l-- > 0)
               {
                  sMap = sMap$":"$l$",";
                  NewMaps = NewMaps$sMap;
               }
           }
           GameMapLimits[i].Maps = NewMaps;
        }
        if (bAdjustIndividualGames)
            break;
    }
    SaveConfig();
}

function bool CheckMap(int GameNum, string MapName)
{
    local string sTemp;
	local int j;

    if (RepeatLimit < 1)
        return false;

    if (Left(MapName, 3) == "[G]")              // check for games
        return false;
    sTemp = GameMapLimits[GameNum].Maps;
    j = InStr(Caps(sTemp), Caps(MapName));
    if (j != -1)
    {
       return true;
    }
    return false;
}
//
defaultproperties
{
    bAdjustIndividualGames=True
}

