//================================================================================
// MapVoteServerActors
//================================================================================

class MapVoteServerActors extends Info config(MapVoteXD);
//
var MapVoteX MyMut;

struct CustActorList
{
    var() string Game;
    var() string ServerActors;
};

var(Maps) config string TopSvrActor[20];
var() config CustActorList CustomGames[30];
var(Maps) config string BotSvrActor[20];

var string TopDefaultActors[20];
var string CusGameActors[20];
var string BotDefaultActors[20];

var bool bInitialized;

function PostBeginPlay()
{
    local int i;

	if (!bInitialized)
	{
	   bInitialized = true;
	   for (i=0; i<30; i++)
	   {
	        CustomGames[i].Game = class'MapVoteX'.default.GameNames[i];
	   }
	   if (TopSvrActor[0] == "")
	       GetDefaultActors();
	   SaveConfig();
    }
}

function GetDefaultActors()
{
    local string sTemp, sAct;
    local int i, j;

    sTemp = ConsoleCommand("Get Engine.GameEngine ServerActors");
    sTemp = Mid(sTemp, 1);

    j = InStr(sTemp, ")");
    if (j >= 0)
    {
        sTemp = Left(sTemp, j);
        sTemp = sTemp$",";
    }

    for (i=0; i<20; i++)
    {
        j = InStr(sTemp, ",");
        if (j == -1)
            break;
        sAct = Left(sTemp, j);
        sTemp = Mid(sTemp, j+1);
        if (i <= 10)
            TopSvrActor[i] = sAct;
        else
        if (i > 10 && i < 20)
            BotSvrActor[i] = sAct;
    }
}

function WriteServerActors(int iGame)
{
    local string sTemp, sAct;
    local int i, j;

    if (TopSvrActor[0] == "")
        return;

    for (i=0; i<20; i++)
    {
        if (TopSvrActor[i] == "")
           break;
        TopDefaultActors[i] = TopSvrActor[i];
    }

    for (i=0; i<20; i++)
    {
        if (BotSvrActor[i] == "")
           break;
        BotDefaultActors[i] = BotSvrActor[i];
    }

    sTemp = CustomGames[iGame].ServerActors;

    if (Right(sTemp, 1) != ",")
        sTemp = sTemp$",";

    if (Len(sTemp) > 3)
    {
       for (i=0; i<20; i++)
       {
           j = InStr(sTemp, ",");
           if (j == -1)
              break;
           sAct = Left(sTemp, j);
           sTemp = Mid(sTemp, j+1);
		   if (sAct != "")
		   {
              CusGameActors[i] = sAct;
           }
       }
    }

    sTemp = "(";
    for (i=0; i<20; i++)
    {
        if (TopDefaultActors[i] == "")
           break;
        sTemp = sTemp$"\""$TopDefaultActors[i]$"\",";
    }

    for (i=0; i<20; i++)
    {
        if (CusGameActors[i] == "")
           break;
        sTemp = sTemp$"\""$CusGameActors[i]$"\",";
    }

    for (i=0; i<20; i++)
    {
        if (BotDefaultActors[i] == "")
           break;
        sTemp = sTemp$"\""$BotDefaultActors[i]$"\",";
    }

    if (Right(sTemp, 1) == ",")
        sTemp = Left(sTemp, Len(sTemp) - 1);
    sTemp = sTemp$")";
    Level.ConsoleCommand("set Engine.GameEngine ServerActors "$sTemp);
    Level.Game.SaveConfig();
    DebugLog("Set ServerActors:   "$sTemp);
}

function DebugLog (string Msg)
{
	if ( MyMut.bDebugMode )
	{
		Log("**** " $Msg);
	}
}
//
defaultproperties
{
}
