//================================================================================
// MapVoteServerPackages
//================================================================================

class MapVoteServerPackages extends Info config(MapVoteXD);
//
var MapVoteX MyMut;

struct CustPackageList
{
    var() string Game;
    var() string ServerPackages;
};

var(Maps) config string TopSvrPacks[50];
var() config CustPackageList CustomGames[30];
var(Maps) config string BotSvrPacks[50];

var string TopDefaultPacks[50];
var string CusGamePackages[30];
var string BotDefaultPacks[50];

var bool bInitialized;

function PostBeginPlay()
{
    local int i;

	if (!bInitialized)
	{
	   bInitialized = true;
	   for (i=0; i<30; i++)
	   {
	        CustomGames[i].Game = class'MapVoteX'.default.GameNames[i];
	   }
	   if (TopSvrPacks[0] == "")
	       GetDefaultPackages();
	   SaveConfig();
    }
}

function GetDefaultPackages()
{
    local string sTemp, sPack;
    local int i, j;

    sTemp = ConsoleCommand("Get Engine.GameEngine ServerPackages");
    sTemp = Mid(sTemp, 1);

    j = InStr(sTemp, ")");
    if (j >= 0)
    {
        sTemp = Left(sTemp, j);
        sTemp = sTemp$",";
    }

    for (i=0; i<100; i++)
    {
        j = InStr(sTemp, ",");
        if (j == -1)
            break;
        sPack = Left(sTemp, j);
        sTemp = Mid(sTemp, j+1);
        if (i <= 40)
            TopSvrPacks[i] = sPack;
        else
        if (i > 40 && i < 80)
            BotSvrPacks[i] = sPack;
    }
}

function WriteServerPackages(int iGame)
{
    local string sTemp, sPack;
    local int i, j;

    if (TopSvrPacks[0] == "")
        return;

    for (i=0; i<50; i++)
    {
        if (TopSvrPacks[i] == "")
           break;
        TopDefaultPacks[i] = TopSvrPacks[i];
    }

    for (i=0; i<50; i++)
    {
        if (BotSvrPacks[i] == "")
           break;
        BotDefaultPacks[i] = BotSvrPacks[i];
    }

    sTemp = CustomGames[iGame].ServerPackages;

    if (Right(sTemp, 1) != ",")
        sTemp = sTemp$",";

    if (Len(sTemp) > 3)
    {
       for (i=0; i<30; i++)
       {
           j = InStr(sTemp, ",");
           if (j == -1)
              break;
           sPack = Left(sTemp, j);
           sTemp = Mid(sTemp, j+1);
		   if (sPack != "")
		   {
              CusGamePackages[i] = sPack;
           }
       }
    }

    sTemp = "(";
    for (i=0; i<50; i++)
    {
        if (TopDefaultPacks[i] == "")
           break;
        sTemp = sTemp$"\""$TopDefaultPacks[i]$"\",";
    }

    for (i=0; i<30; i++)
    {
        if (CusGamePackages[i] == "")
           break;
        sTemp = sTemp$"\""$CusGamePackages[i]$"\",";
    }

    for (i=0; i<50; i++)
    {
        if (BotDefaultPacks[i] == "")
           break;
        sTemp = sTemp$"\""$BotDefaultPacks[i]$"\",";
    }

    if (Right(sTemp, 1) == ",")
        sTemp = Left(sTemp, Len(sTemp) - 1);
    sTemp = sTemp$")";
    Level.ConsoleCommand("set Engine.GameEngine ServerPackages "$sTemp);
    Level.Game.SaveConfig();
    DebugLog("Set ServerPackages: "$sTemp);
}

function DebugLog (string Msg)
{
	if ( MyMut.bDebugMode )
	{
		Log("**** " $Msg);
	}
}
//
defaultproperties
{
}
