//================================================================================
// MapVoteTabWindow.
//================================================================================
class MapVoteTabWindow extends UWindowDialogClientWindow;
//
var UMenuPageControl     Pages;
var MapVoteWindowVote    MapWindow;
var MapVoteWindowInfo    InfoWindow;
var MapVoteWindowAdmin   AdminWindow;
var MapVoteWindowWelcome WelcomeWindow;
var MapVoteWindowMesg    MesgWindow;

var string PrevSelectedMap;
var string PrevSelectedPlayer;
var string MapPref;

var bool bDone;
var int  iWebDone;
var int  iStuff;
var bool bAdminMesg;
var bool bWelcomeMenu;
var bool bGameHasEnded;
var bool bAdmin;
var bool bMidGame;

var int TickTock;

function Created ()
{
	Super.Created();

	bDone = false;
	iWebDone = 0;
	iStuff = 0;
}

function SetupMapWindow(bool bMesg, int iAdmin, int iWelcome, int iEndGame, int iWelcomeFirst, int iService, int iMidGame, string Pref)
{
	local UWindowPageControlPage PageControl;
	local Playerpawn P;
    local bool bAdmin;
	P = GetPlayerOwner();

    bAdmin = bool(iAdmin);
    MapPref = Pref;

    if (P != None)
    {
        if (bAdmin == false)
            bAdmin = P.PlayerReplicationInfo.bAdmin;
    }

    bWelcomeMenu = bool(iWelcome);
    bGameHasEnded = bool(iEndGame);
    bMidGame = bool(iMidGame);

	WinLeft = (Root.WinWidth  - WinWidth)  / 2;
	WinTop  = (Root.WinHeight - WinHeight) / 2;

	Pages = UMenuPageControl(CreateWindow(Class'MapVotePageControl',0.00,0.00,WinWidth,WinHeight));
	Pages.SetMultiLine(True);   // kills the <> on the right edge :)

    if ( bMesg )
    {
	   bAdminMesg = true;
	   PageControl = Pages.AddPage("Admin Messages",Class'MapVoteWindowMesg');
	   MesgWindow = MapVoteWindowMesg(PageControl.Page);
	   return;
    }

    if ( bGameHasEnded )
    {
       PageControl = Pages.AddPage("Voting",Class'MapVoteWindowVote');
       MapWindow = MapVoteWindowVote(PageControl.Page);

       if ( bWelcomeMenu )
       {
          PageControl = Pages.AddPage("Welcome",Class'MapVoteWindowWelcome');
	      WelcomeWindow = MapVoteWindowWelcome(PageControl.Page);
	   }

       PageControl = Pages.AddPage("Info",Class'MapVoteWindowInfo');
       InfoWindow = MapVoteWindowInfo(PageControl.Page);

       if ( bAdmin )
       {
	      PageControl = Pages.AddPage("Admin",Class'MapVoteWindowAdmin');
	      AdminWindow = MapVoteWindowAdmin(PageControl.Page);
	      if (iService == 1)
	         AdminWindow.MainButton.Text = "Maintenance Off";
	      else
             AdminWindow.MainButton.Text = "Maintenance On";
       }

       LoadMaps();
       return;
    }

    if ( bWelcomeMenu && iWelcomeFirst == 1 )
    {
	   PageControl = Pages.AddPage("Welcome",Class'MapVoteWindowWelcome');
	   WelcomeWindow = MapVoteWindowWelcome(PageControl.Page);
	}

    if ( iMidGame == 1 || bAdmin)
    {
	   PageControl = Pages.AddPage("Voting",Class'MapVoteWindowVote');
	   MapWindow = MapVoteWindowVote(PageControl.Page);
	}

    if ( bWelcomeMenu && iWelcomeFirst == 0 )
    {
       PageControl = Pages.AddPage("Welcome",Class'MapVoteWindowWelcome');
       WelcomeWindow = MapVoteWindowWelcome(PageControl.Page);
    }

    PageControl = Pages.AddPage("Info",Class'MapVoteWindowInfo');
    InfoWindow = MapVoteWindowInfo(PageControl.Page);

    if ( bAdmin )
    {
	   PageControl = Pages.AddPage("Admin",Class'MapVoteWindowAdmin');
	   AdminWindow = MapVoteWindowAdmin(PageControl.Page);
	   if (iService == 1)
	      AdminWindow.MainButton.Text = "Maintenance Off";
	   else
          AdminWindow.MainButton.Text = "Maintenance On";
	}

    if (MapWindow != None)
        LoadMaps();
}

function LoadMaps()
{
    local MapVoteGRI MVGRI;
    local string sTemp, GameMap;
    local int i, j, k, x;

    if ( MVGRI == none )
    {
       foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
       break;
    }

    if (MapPref == "")
        MapPref = MVGRI.GameStuff[63];

    ClearList(1);
    ClearList(2);

    j = 0;
    for (i=0; i<30; i++)
    {
		sTemp = MVGRI.GameStuff[i];
		if (sTemp != "")
		{
		   GameMap = "";
           AddMapName(2, sTemp, j, 0);
           k = 0;
	       if (Caps(Mid(sTemp, 3)) == Caps(MVGRI.GameStuff[62])) // MVGameName
	           k = 1;
	       GameMap = MVGRI.GameStuff[j+1+30];
	       AddMapName(3, GameMap, j, k);
	       j++;
        }
        if (i > 1 && sTemp == "")
            break;
    }

    j = 0;
    for (i=0; i<500; i++)
    {
        if (i < 256)
		    sTemp = MVGRI.ListedMaps1[i];
		else
		    sTemp = MVGRI.ListedMaps2[i-255];

		if (sTemp != "")
		{
		   if (Left(sTemp, 3) != "[G]")
		   {
		      AddMapName(1, sTemp, 0, 0);
		   }
		}
		else
		{
		   j++;
   		   if (j > 3)
		      break;
		}
    }
}

function AddMapName(int listNum, string MapName, int x, optional int k)
{
	local MapVoteUMenuList MVUM;

	if ( listNum == 1 )
	{
		MVUM = MapVoteUMenuList(MapWindow.MapListBox.Items.Append(Class'MapVoteUMenuList'));
	    if ( Left(MapName,3) ~= "[X]" )
		    MapName = "[X]"$MapPref$"-"$Mid(MapName,3);
	    else
	        MapName = MapPref$"-"$MapName;
	}
    else
	if ( listNum == 2 )   // [G]Capture the Flag
	{
		MVUM = MapVoteUMenuList(MapWindow.GameListBox.Items.Append(Class'MapVoteUMenuList'));
		MapWindow.GameList[x] = MapName;
		MVUM.GameName = MapName;
	}
    else
	if ( listNum == 3 )
	{
		MapWindow.GameMaps[x] = MapName;
		if (k == 1)
		   MapWindow.SetMap(MapWindow.CheckMapname(MapName));
		return;
	}
	MVUM.MapName = MapName;
}

function AddMessage(string MesgName)
{
	local MapVoteUMenuList i;

	i = MapVoteUMenuList(MesgWindow.MesgListBox.Items.Append(Class'MapVoteUMenuList'));
	i.MapName = MesgName;
}

function SetupMenu(string sCod, string Vers, int iAdm, string Stuff, string svrName, string svrPort, string svrIP)
{
    if (bAdminMesg)
        return;

    if (iAdm == 1 && iStuff < 10)
    {
       AdminWindow.SetupStuff(Stuff);
       AdminWindow.sCode = sCod;
       iStuff++;
    }

    InfoWindow.Version = Vers;
    InfoWindow.sCode   = sCod;

    if (svrIP != "" && svrPort != "")
    {
       if (bWelcomeMenu)
       {
          WelcomeWindow.BookButton.bDisabled = False;
          WelcomeWindow.ServerName = svrName;
          WelcomeWindow.ServerPort = svrPort;
          WelcomeWindow.ServerIP = svrIP;
       }
       else
       {
          InfoWindow.BookButton.bDisabled = False;
          InfoWindow.ServerName = svrName;
          InfoWindow.ServerPort = svrPort;
          InfoWindow.ServerIP = svrIP;
       }
    }

    if ( bGameHasEnded || (!bGameHasEnded && bMidGame) || iAdm == 1 )
    {
       MapWindow.sCode    = sCod;
    }
}

function SetupWelcome(string Stretch, string sLogo, string sSound, string sWeb, string sMail, string AnonButName, string AnonButURL)
{
    if (WelcomeWindow != None && iWebDone < 3)
    {
        WelcomeWindow.bStretch      = false;
        if (Stretch == "1")
            WelcomeWindow.bStretch  = True;
        WelcomeWindow.MenuLogoName  = sLogo;
        WelcomeWindow.MenuSoundName = sSound;
        WelcomeWindow.WebsiteURL    = sWeb;
        WelcomeWindow.ContactURL    = sMail;
        if (sWeb != "")
            WelcomeWindow.WebButton.bDisabled=False;
        if (sMail != "")
            WelcomeWindow.MailButton.bDisabled=False;
        if (AnonButName != "" && AnonButURL != "")
        {
            WelcomeWindow.AnonButton.Text = AnonButName;
            WelcomeWindow.AnonButtonURL = AnonButURL;
            WelcomeWindow.AnonButton.bDisabled = false;
        }
        iWebDone++;
    }
}

function ClearList(int listNum)
{
    if (!bDone)
    {
        bDone = true;
        MapWindow.SetupClientWindow();
    }

	if ( listNum == 1 )
		MapWindow.MapListBox.Items.Clear();
	else
    if ( listNum == 2 )
		MapWindow.GameListBox.Items.Clear();
}

function ClearMesgs()
{
    MesgWindow.MesgListBox.Items.Clear();
}

function AddPlayerName (string PlayerName)
{
	local MapVotePlayerListItem i;
	local UWindowList Item;
	local int j;

	Item = MapWindow.ListVotePlayer.Items;
	for (Item = MapWindow.ListVotePlayer.Items; Item != None; Item=Item.Next)
	{
		if ( MapVotePlayerListItem(Item).PlayerName == PlayerName )
			return;
	}

	i = MapVotePlayerListItem(MapWindow.ListVotePlayer.Items.Append(Class'MapVotePlayerListItem'));
	i.PlayerName = PlayerName;
}

simulated function UpdateMapVoteResults (string Text, int i)
{
	local UWindowList Item;
	local string MapName;
	local int pos;
	local float C;

	if ( Text == "Clear" )
	{
		if ( MapWindow.ListVoteStatus.SelectedItem != None )
		{
			PrevSelectedMap = MapVoteStatusListItem(MapWindow.ListVoteStatus.SelectedItem).MapName;
		}
		MapWindow.ListVoteStatus.Items.Clear();
		return;
	}
	pos = InStr(Text, ",");
	if ( pos > 0 )
	{
		MapName = Left(Text, pos);
		C = float(Mid(Text, pos + 1));
	}

    // check to see if MapName is already in the list
    for(Item = MapWindow.ListVoteStatus.Items; Item != None; Item = Item.Next)
    {
        if (MapVoteStatusListItem(Item).MapName == MapName)
        {
            MapVoteStatusListItem(Item).Rank = i + 1;
            MapVoteStatusListItem(Item).VoteCount = c;
            return;
        }
    }

	Item = MapVoteStatusListItem(MapWindow.ListVoteStatus.Items.Append(Class'MapVoteStatusListItem'));
	MapVoteStatusListItem(Item).rank = i + 1;
	MapVoteStatusListItem(Item).MapName = MapName;
	MapVoteStatusListItem(Item).VoteCount = C;
	if ( PrevSelectedMap == MapName )
	{
		MapWindow.ListVoteStatus.SelectMap(PrevSelectedMap);
	}
}
//
defaultproperties
{
}
