//================================================================================
// MapVoteWindowAdmin.
//================================================================================

class MapVoteWindowAdmin extends UWindowPageWindow;
//
var color WhiteColor, GrayColor;

var UWindowCheckbox CheckAutoOpen;
var UWindowCheckbox CheckMidGame;
var UWindowCheckbox CheckDebugMode;
var UWindowCheckbox CheckXOptions;
var UWindowCheckbox CheckMajority;

var UWindowCheckbox CheckSvrLogo;
var UWindowCheckbox CheckAdverts;
var UWindowCheckbox CheckWelFirst;
var UWindowCheckbox CheckSortGame;
var UWindowCheckbox CheckEmptySwt;

var UWindowHSliderControl SlideTime;
var UMenuLabelControl     LabelTime;
var UWindowHSliderControl SlideDely;
var UMenuLabelControl     LabelDely;
var UWindowHSliderControl SlideVote;
var UMenuLabelControl     LabelVote;
var UWindowHSliderControl SlidePopup;
var UMenuLabelControl     LabelPopup;
var UWindowHSliderControl SlideRepeat;
var UMenuLabelControl     LabelRepeat;

var UMenuLabelControl     LabelHelp;

var UWindowSmallButton MainButton;
var MapVoteSmallButton MesgButton;

var UWindowSmallButton AddBotButton;
var UWindowSmallButton RemBotButton;
var UWindowSmallButton EndedButton;

var UWindowSmallButton SubmitButton;
var UWindowSmallButton CloseButton;
var UWindowSmallButton PauseButton;

var bool bStuffSet;
var string sCode;
var bool   bInitialized;

var bool bHelp;
var int  HelpCount;

var MapVoteGRI MVGRI;
var int  TickTock;

function Created ()
{
	Super.Created();

    bInitialized = false;
    bStuffSet = false;

    CheckAutoOpen = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 20, 40, 160, 1));
    CheckAutoOpen.TextColor = WhiteColor;
    CheckAutoOpen.SetText("Auto Open Vote Menu");

    CheckMidGame = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 20, 60, 160, 1));
    CheckMidGame.TextColor = WhiteColor;
    CheckMidGame.SetText("Enable Mid Game Voting");

    CheckDebugMode = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 20, 80, 160, 1));
    CheckDebugMode.TextColor = WhiteColor;
    CheckDebugMode.SetText("Enable Log Debug Mode");

    CheckXOptions = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 20, 100, 160, 1));
    CheckXOptions.TextColor = WhiteColor;
    CheckXOptions.SetText("Enable !Command Options");

    CheckMajority = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 20, 120, 160, 1));
    CheckMajority.TextColor = WhiteColor;
    CheckMajority.SetText("Enable Majority Playervote");

    CheckSvrLogo = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 210, 40, 160, 1));
    CheckSvrLogo.TextColor = WhiteColor;
    CheckSvrLogo.SetText("Enable Logon Splashlogo");

    CheckAdverts = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 210, 60, 160, 1));
    CheckAdverts.TextColor = WhiteColor;
    CheckAdverts.SetText("Enable Welcome Menu");

    CheckWelFirst = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 210, 80, 160, 1));
    CheckWelFirst.TextColor = WhiteColor;
    CheckWelFirst.SetText("Show Welcome First");

    CheckSortGame = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 210, 100, 160, 1));
    CheckSortGame.TextColor = WhiteColor;
    CheckSortGame.SetText("Sort Custom Game List");

    CheckEmptySwt = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 210, 120, 160, 1));
    CheckEmptySwt.TextColor = WhiteColor;
    CheckEmptySwt.SetText("Enable Empty Server Switch");

    LabelHelp = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 80, 140, 240, 16));
    LabelHelp.SetText("");
    LabelHelp.TextColor = GrayColor;

    SlideTime = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 55, 160, 220, 30));
    SlideTime.bAcceptsFocus = False;
    SlideTime.MinValue = 5;
    SlideTime.MaxValue = 60;
    SlideTime.Step = 5;
    SlideTime.SetText("Empty Server Switch");
    SlideTime.SetValue(15);
    SlideTime.TextColor = WhiteColor;

    LabelTime = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 285, 160, 60, 16));
    LabelTime.SetText("");
    LabelTime.TextColor = WhiteColor;

    SlideDely = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 55, 178, 220, 30));
    SlideDely.bAcceptsFocus = False;
    SlideDely.MinValue = 1;
    SlideDely.MaxValue = 30;
    SlideDely.Step = 1;
    SlideDely.SetText("Game Start Vote Delay");
    SlideDely.SetValue(15);
    SlideDely.TextColor = WhiteColor;

    LabelDely = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 285, 178, 60, 16));
    LabelDely.SetText("");
    LabelDely.TextColor = WhiteColor;

    SlideVote = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 55, 196, 220, 30));
    SlideVote.bAcceptsFocus = False;
    SlideVote.MinValue = 10;
    SlideVote.MaxValue = 180;
    SlideVote.Step = 10;
    SlideVote.SetText("Voting Time Limit");
    SlideVote.SetValue(50);
    SlideVote.TextColor = WhiteColor;

    LabelVote = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 285, 196, 60, 16));
    LabelVote.SetText("");
    LabelVote.TextColor = WhiteColor;

    SlidePopup = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 55, 214, 220, 30));
    SlidePopup.bAcceptsFocus = False;
    SlidePopup.MinValue = 2;
    SlidePopup.MaxValue = 30;
    SlidePopup.Step = 2;
    SlidePopup.SetText("Menu Popup Delay");
    SlidePopup.SetValue(10);
    SlidePopup.TextColor = WhiteColor;

    LabelPopup = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 285, 214, 60, 16));
    LabelPopup.SetText("");
    LabelPopup.TextColor = WhiteColor;

    SlideRepeat = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 55, 232, 220, 30));
    SlideRepeat.bAcceptsFocus = False;
    SlideRepeat.MinValue = 0;
    SlideRepeat.MaxValue = 20;
    SlideRepeat.Step = 1;
    SlideRepeat.SetText("Map Repeat Limit");
    SlideRepeat.SetValue(5);
    SlideRepeat.TextColor = WhiteColor;

    LabelRepeat = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 285, 232, 60, 16));
    LabelRepeat.SetText("");
    LabelRepeat.TextColor = WhiteColor;

    MainButton=MapVoteSmallButton(CreateControl(Class'MapVoteSmallButton', 15, 255, 110, 20));
	MainButton.DownSound=Sound'GlassTink1';
	MainButton.Text="Maintenance Mode";
	MainButton.bDisabled=False;

    MesgButton=MapVoteSmallButton(CreateControl(Class'MapVoteSmallButton', 270, 255, 110, 20));
	MesgButton.DownSound=Sound'GlassTink1';
	MesgButton.Text="Admin Messages";
	MesgButton.bDisabled=False;

    AddBotButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',15, 275, 110, 20));
	AddBotButton.DownSound=Sound'GlassTink1';
	AddBotButton.Text="Add a Bot";
	AddBotButton.bDisabled=False;

    SubmitButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',140, 275, 115, 20));
	SubmitButton.DownSound=Sound'Reload';
	SubmitButton.Text="Submit";
	SubmitButton.bDisabled=False;

    RemBotButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',270, 275, 110, 20));
	RemBotButton.DownSound=Sound'GlassTink1';
	RemBotButton.Text="Kill a Bot";
	RemBotButton.bDisabled=False;

    EndedButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',15, 295, 110, 20));
	EndedButton.DownSound=Sound'GlassTink1';
	EndedButton.Text="End Game";
	EndedButton.bDisabled=False;

    CloseButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',140, 295, 115, 20));
	CloseButton.DownSound=Sound'Reload';
	CloseButton.Text="Close";
	CloseButton.bDisabled=False;

    PauseButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',270, 295, 110, 20));
	PauseButton.DownSound=Sound'GlassTink1';
	PauseButton.Text="Pause Game";
	PauseButton.bDisabled=False;

    SetAcceptsFocus();
    bInitialized = true;
    TimeChanged();
    DelyChanged();
    VoteChanged();
    PopupChanged();
    RepeatChanged();
    Enable('Tick');
}

function Notify (UWindowDialogControl C, byte E)
{
    Super.Notify(C,E);

    Switch(E)
    {
	  case DE_Click:
	  switch(C)
      {
      case MainButton:
           ParentWindow.ParentWindow.Close();
           GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"SetupServerMaintenance");
           break;
      case MesgButton:
           ParentWindow.ParentWindow.Close();
           GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"DisplayAdminMessages");
           break;
      case AddBotButton:
           GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"AddBot");
           break;
      case RemBotButton:
           GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"RemBot");
           break;
      case PauseButton:
           ParentWindow.ParentWindow.Close();
           GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"PauseGame");
           break;
      case EndedButton:
           ParentWindow.ParentWindow.Close();
           GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"ForceGameEnd");
           break;
      case SubmitButton:
           SubmitStuff();
           ParentWindow.ParentWindow.Close();
           break;
      case CloseButton:
           ParentWindow.ParentWindow.Close();
           break;
      }
      break;
      case DE_Change:
      switch(C)
      {
      case CheckDebugMode:
      case CheckXOptions:
      case CheckSvrLogo:
      case CheckSortGame:
      case CheckEmptySwt:
         ShowHelp();
         break;
      case SlideTime:
         TimeChanged();
         break;
      case SlideDely:
         DelyChanged();
         break;
      case SlideVote:
         VoteChanged();
         break;
      case SlidePopup:
         PopupChanged();
         break;
      case SlideRepeat:
         RepeatChanged();
         break;
      }
      break;
    }
}

function ShowHelp()
{
    LabelHelp.SetText("This option will only be take place on the next level!");
    HelpCount = 0;
    bHelp = True;
}

function SetupStuff(string Stuff)
{
    local int i;
    local string sTemp;

    if (!bStuffSet && Len(Stuff) > 20)
    {
       bStuffSet = True;

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckAutoOpen.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckMidGame.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckDebugMode.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckXOptions.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckMajority.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckSvrLogo.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckAdverts.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckWelFirst.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckSortGame.bChecked = bool(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       CheckEmptySwt.bChecked = bool(i);

       //---------------- sliders -------------------

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       SlideTime.SetValue(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       SlideDely.SetValue(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       SlideVote.SetValue(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       Stuff = Mid(Stuff, i+1);
       i = int(sTemp);
       SlidePopup.SetValue(i);

       i = InStr(Stuff, ",");
       sTemp = Left(Stuff, i);
       i = int(sTemp);
       SlideRepeat.SetValue(i);
    }
}

function SubmitStuff()
{
    local string sTemp, s0, s1;

    s0 = "0,";
    s1 = "1,";

    if (CheckAutoOpen.bChecked)       // wouldn't work any other way ?
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckMidGame.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckDebugMode.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckXOptions.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckMajority.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckSvrLogo.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckAdverts.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckWelFirst.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckSortGame.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    if (CheckEmptySwt.bChecked)
        sTemp = sTemp$s1;
    else
        sTemp = sTemp$s0;

    //---------------- sliders -------------------

    sTemp = sTemp$string(int(SlideTime.Value))$","$string(int(SlideDely.Value))$","$string(int(SlideVote.Value))$",";
    sTemp = sTemp$string(int(SlidePopup.Value))$","$string(int(SlideRepeat.Value))$",";

    GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"Admin "$sTemp);
}

function TimeChanged()
{
    if (bInitialized)
       LabelTime.SetText(string(int(SlideTime.Value)) $ " Minutes");
}

function DelyChanged()
{
    if (bInitialized)
       LabelDely.SetText(string(int(SlideDely.Value)) $ " Seconds");
}

function VoteChanged()
{
    if (bInitialized)
       LabelVote.SetText(string(int(SlideVote.Value)) $ " Seconds");
}

function PopupChanged()
{
    if (bInitialized)
       LabelPopup.SetText(string(int(SlidePopup.Value)) $ " Seconds");
}

function RepeatChanged()
{
    if (bInitialized)
    {
       if (SlideRepeat.Value < 1)
          LabelRepeat.SetText("Disabled");
       else
          LabelRepeat.SetText(string(int(SlideRepeat.Value)) $ " Levels");
    }
}

function Tick (float DeltaTime)
{
    Super.Tick(DeltaTime);

    if (bHelp && HelpCount++ == 200)
    {
        LabelHelp.SetText("");
        bHelp = false;
    }

    if (TickTock++ == 10)
    {
        if ( MVGRI == none )
        {
           foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
           break;
        }
        sCode = MVGRI.sCode;
    }
}

function Paint (Canvas C, float MouseX, float MouseY)
{
    local Texture MVX;

	Super.Paint(C,MouseX,MouseY);

    MVX = Texture'mvx1';

    DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'grad1');

    C.Style = GetPlayerOwner().ERenderStyle.STY_Translucent;
    C.SetPos( C.ClipX / 2 - MVX.Usize / 2 - 4, 7);
    C.DrawIcon( MVX, 1.0 );
    C.Style = GetPlayerOwner().ERenderStyle.STY_Normal;
}

function Close (optional bool bByParent)
{
	Super.Close(bByParent);
}
//
defaultproperties
{
    GrayColor=(R=128,G=128,B=128)
    WhiteColor=(R=255,G=255,B=255)
}
