//================================================================================
// MapVoteWindowVote.
//================================================================================
class MapVoteWindowVote extends UWindowPageWindow;
//
#exec texture IMPORT NAME=grad1 File=Textures\grad01.pcx GROUP=Mapvote MIPS=OFF

var MapVoteListBox MapListBox;
var MapVoteListBox GameListBox;
var UWindowSmallButton FontButton;
var UWindowSmallButton VoteButton1;
var UWindowSmallButton PlayButton;
var UWindowSmallButton SendButton;
var UWindowSmallButton CloseButton;
var MapVoteStatusListBox ListVoteStatus;
var MapVotePlayerListBox ListVotePlayer;
var UMenuLabelControl lblStatusTitles;
var UMenuLabelControl lblTitle1;
var UMenuLabelControl lblGametxt1;
var UMenuLabelControl lblMaptxt1;
var UMenuLabelControl lblMesg;
var MapVoteEditControl txtMessage;
var Texture Screenshot;
var string MapTitle;
var string IdealPlayerCount;
var float LastVoteTime;
var float SelectionTime;
var string LogoTexture;
var int MapListwidth;
var int ListHeight;
var bool bMapAlreadySet;

var string GameList[31];
var string GameMaps[31];
var string ThisGame;
var string GameMap;
var string sCode;
var string sGameNum;
var string sMapPref;

var bool bGameSelect;
var bool bShowPlayers;

var MapVoteGRI MVGRI;

function Created ()
{
    local int i;

    for (i=0; i<31; i++)
    {
        GameList[i] = "";
        GameMaps[i] = "";
    }

	Super.Created();
}

function SetupClientWindow()
{
	local Color TextColor;
	local Color TextColorRed;
	local Color TextColorGrey;
	local Color TextColorGreen;
	local Color TextColorYellow;
	local int LowSectionPos;
	local int RightSectionStart;
    local int VoteP, SendS, EditW, ClosS;

   	TextColor.R=255;
	TextColor.G=255;
	TextColor.B=255;
	TextColorRed.R=255;
	TextColorRed.G=10;
	TextColorRed.B=10;
	TextColorGreen.R=0;
	TextColorGreen.G=255;
	TextColorGreen.B=32;
	TextColorYellow.R=255;
	TextColorYellow.G=255;
	TextColorYellow.B=10;
	TextColorGrey.R=64;
	TextColorGrey.G=64;
	TextColorGrey.B=64;

	MapListwidth=180;
	ListHeight=240;
	LowSectionPos=ListHeight + 55;
	RightSectionStart=330;

    VoteP = 273;
    EditW = 186; //360;
    SendS = 246; //426;
    ClosS = 315;

    if ( MVGRI == none )
    {
       foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
       break;
    }

    ThisGame = MVGRI.GameStuff[62]; // mvgamename
    sMapPref = MVGRI.GameStuff[63]; // map prefix
    sGameNum = MVGRI.GameStuff[64]; // number of games

    if (sCode == "")                // incase it come up the player train
        sCode = MVGRI.sCode;

	lblTitle1=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',0.00,10.00,MapListwidth,20.00));
	lblTitle1.SetText(ThisGame);
	lblTitle1.Align=TA_Center;
	lblTitle1.SetTextColor(TextColorYellow);

	MapListBox=MapVoteListBox(CreateControl(Class'MapVoteListBox',10.00,26.00,MapListwidth,ListHeight));
	MapListBox.Items.Clear();

	lblStatusTitles=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',25.00 + MapListwidth,10.00,MapListwidth+5,20.00));
	lblStatusTitles.SetText("Pos   Voted Item                      Votes");
	lblStatusTitles.SetFont(0);
	lblStatusTitles.SetTextColor(TextColor);

	ListVoteStatus=MapVoteStatusListBox(CreateControl(Class'MapVoteStatusListBox',20.00 + MapListwidth,27,MapListwidth+5, 110));
	ListVoteStatus.bAcceptsFocus=False;
	ListVoteStatus.Items.Clear();

	ListVotePlayer=MapVotePlayerListBox(CreateControl(Class'MapVotePlayerListBox',20.00 + MapListwidth,27,MapListwidth+5, 110));
	ListVotePlayer.bAcceptsFocus=False;
	ListVotePlayer.Items.Clear();
    ListVotePlayer.WinHeight=0;

	lblMaptxt1=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',20.00 + MapListwidth,140.00,MapListwidth,10.00));
	lblMaptxt1.SetTextColor(TextColor);
	lblMaptxt1.Align=TA_Center;

    if (sGameNum != "1")
    {
	   lblGametxt1=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',20.00 + MapListwidth,153.00,MapListwidth,10.00));
	   lblGametxt1.SetFont(1);
	   lblGametxt1.SetText("Game List");
	   lblGametxt1.Align=TA_Center;
	   lblGametxt1.SetTextColor(TextColorYellow);
    }

    if (sGameNum == "1")
	   GameListBox=MapVoteListBox(CreateControl(Class'MapVoteListBox', 0, 0, 0, 0));
	else
	   GameListBox=MapVoteListBox(CreateControl(Class'MapVoteListBox', 20.00 + MapListwidth, 168.00, MapListwidth+5, 97));
	GameListBox.Items.Clear();
	GameListBox.ThisGame = ThisGame;
	GameListBox.sGameNum = sGameNum;

	FontButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 10, VoteP, 70, 21));
	FontButton.DownSound=Sound'GlassTink1';
	FontButton.Text="Font";
	FontButton.bDisabled=False;
                                                                                     //180
	VoteButton1=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 84, VoteP, 227, 21));
	VoteButton1.DownSound=Sound'GlassTink2';
	VoteButton1.Text="Vote";
	VoteButton1.bDisabled=False;
                                                                                       //55       //185
	PlayButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 315, VoteP, 70, 20));
	PlayButton.DownSound=Sound'GlassTink1';
	PlayButton.Text="Voted";
	PlayButton.bDisabled=False;
                                                                                       //20      //185
	lblMesg=UMenuLabelControl(CreateControl(Class'UMenuLabelControl', 10, LowSectionPos, 40, 16));
	lblMesg.SetText("Message");
	lblMesg.SetFont(0);
	lblMesg.SetTextColor(TextColor);

	txtMessage=MapVoteEditControl(CreateControl(Class'MapVoteEditControl',55.00,LowSectionPos,EditW,16));
	txtMessage.SetNumericOnly(False);
	txtMessage.SetHistory(True);
	txtMessage.SetMaxLength(80);
	txtMessage.SetValue("");
	txtMessage.Align=TA_Left;

	SendButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', SendS, LowSectionPos, 65, 20));
	SendButton.DownSound=Sound'GlassTink1';
	SendButton.Text="Send";
	SendButton.bDisabled=False;                                                 // horzpos,vertpos,width,height

    CloseButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', ClosS, LowSectionPos, 70, 20));
	CloseButton.DownSound=Sound'Reload';
	CloseButton.Text="Close";
	CloseButton.bDisabled=False;

}

function DeSelectAllOtherMapListBoxItems(MapVoteListBox SelListBox, int iNum)
{
	if ( iNum != 1 )
	{
		if ( MapListBox.SelectedItem != None )
		{
			MapListBox.SelectedItem.bSelected = False;
		}
		MapListBox.SelectedItem = None;
	}

	if ( iNum != 2 )
	{
		if ( GameListBox.SelectedItem != None )
		{
			GameListBox.SelectedItem.bSelected = False;
		}
		GameListBox.SelectedItem = None;
	}

	if ( iNum == 1 || iNum == 2 )
	{
		SelListBox.MakeSelectedVisible();
	}
}

function UWindowListBoxItem GetSelectedItem ()
{
	if ( MapListBox.SelectedItem != None )
	{
		return MapListBox.SelectedItem;
	}
	if ( GameListBox.SelectedItem != None )
	{
		return GameListBox.SelectedItem;
	}
}

function Notify (UWindowDialogControl C, byte E)
{
    local string sTemp;
	local int ListNum, i;

	Super.Notify(C, E);
	switch (E)
	{
		case 1:
		switch (C)
		{
			default:
		}
		break;
		case 11:    // double click listboxes removed as it's possible to vote random times per map
		switch (C)
		{
			case ListVoteStatus:
			ListNum = GetListNum(MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName);
			DeSelectAllOtherMapListBoxItems(MapListBox, 0);
			if ( ListNum == 1 )
			{
				MapListBox.SelectMap(MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName);
			}
			if ( ListNum == 2 )
			{
				GameListBox.SelectMap(MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName);
			}

			if ( GetPlayerOwner().Level.TimeSeconds > LastVoteTime + 5 )
			{
			    if ( ListNum == 1 )
				   GetPlayerOwner().ConsoleCommand("MUTATE MAPVOTEX "$sCode$"MAP " $ MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName);
				else
				{
				   sTemp = MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName;
				   if (Left(sTemp, 3) != "[G]")
				      sTemp = "[G]"$sTemp;
				   GetPlayerOwner().ConsoleCommand("MUTATE MAPVOTEX "$sCode$"GAME " $sTemp);
				}
				LastVoteTime = GetPlayerOwner().Level.TimeSeconds;
			}
			SelectionTime = GetPlayerOwner().Level.TimeSeconds;
			break;
			default:
		}
		break;
		case 2:
		switch (C)
		{
			case SendButton:
			if ( txtMessage.GetValue() != "" )
			{
				GetPlayerOwner().ConsoleCommand("SAY " $ txtMessage.GetValue());
				txtMessage.SetValue("");
			}
			break;

			case VoteButton1:
			if ( GetPlayerOwner().Level.TimeSeconds > LastVoteTime + 5 )
			{
				if ( getSelectedItem() != None )
				{
					if ( (Left(MapVoteUMenuList(getSelectedItem()).MapName,3) != "[X]") || GetPlayerOwner().PlayerReplicationInfo.bAdmin )
					{
						sTemp = MapVoteUMenuList(getSelectedItem()).MapName;
						if (sTemp != "")
						{
						   if (CheckForGame(sTemp))
						      GetPlayerOwner().ConsoleCommand("MUTATE MAPVOTEX "$sCode$"GAME "$sTemp);
						   else
						      GetPlayerOwner().ConsoleCommand("MUTATE MAPVOTEX "$sCode$"MAP "$sTemp);
						}
						LastVoteTime = GetPlayerOwner().Level.TimeSeconds;
					}
				}
			}
			break;

			case PlayButton:
	        bShowPlayers  = !bShowPlayers;
	        if (bShowPlayers)
	        {
                lblStatusTitles.SetText("       Players that have Voted");
                ListVoteStatus.WinHeight=0;
                ListVotePlayer.WinHeight=110;
            }
	        else
	        {
                lblStatusTitles.SetText("Pos   Voted Item                      Votes");
                ListVoteStatus.WinHeight=110;
                ListVotePlayer.WinHeight=0;
            }
            break;

			case FontButton:
	        MapListBox.bBold  = !MapListBox.bBold;
	        GameListBox.bBold = !GameListBox.bBold;
	        if (MapListBox.bBold)
	        {
	        	lblTitle1.SetFont(1);
	        	lblMaptxt1.SetFont(1);
	        }
	        else
	        {
	        	lblTitle1.SetFont(0);
	        	lblMaptxt1.SetFont(0);
	        }
            break;

			case CloseButton:
			ParentWindow.ParentWindow.Close();
			break;

			case MapListBox:
			bGameSelect = false;
			MapListBox.VScrol = 19;
			MapListBox.sMapPref = sMapPref;
			SelectionTime = GetPlayerOwner().Level.TimeSeconds;
			DeSelectAllOtherMapListBoxItems(MapListBox, 1);
			break;

			case GameListBox:
			bGameSelect = True;
			GameListBox.VScrol = 7;
			GameListBox.sMapPref = "";
			SelectionTime = GetPlayerOwner().Level.TimeSeconds;
			DeSelectAllOtherMapListBoxItems(GameListBox, 2);
			FindGameMap(MapVoteUMenuList(getSelectedItem()).MapName);
			break;

			case ListVoteStatus:
			ListNum = GetListNum(MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName);
			DeSelectAllOtherMapListBoxItems(MapListBox, 0);
			if ( ListNum == 1 )
			{
				MapListBox.SelectMap(MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName);
			}
			if ( ListNum == 2 )
			{
				GameListBox.SelectMap(MapVoteStatusListItem(ListVoteStatus.SelectedItem).MapName);
			}
			SelectionTime = GetPlayerOwner().Level.TimeSeconds;
			break;
			default:
		}
		break;
		case 7:
		if ( txtMessage.GetValue() != "" )
		{
			GetPlayerOwner().ConsoleCommand("SAY " $ txtMessage.GetValue());
			txtMessage.SetValue("");
			txtMessage.FocusOtherWindow(SendButton);
		}
		break;
		default:
	}
}

function int GetListNum (string ItemName)
{
	local int iNum;

    if ( ItemName == "")
        iNum = 0;
    else
	if ( MapListBox.isItemInList(ItemName) )
		iNum = 1;
	else
		iNum = 2;

	return iNum;
}

function FindGameMap(string sGame)
{
     local int i;

     GameMap = "";
     for (i=0; i<30; i++)
     {
         if (GameList[i] == sGame)
         {
             GameMap = GameMaps[i];
             break;
         }
     }
}

function bool CheckForGame(string sGame)
{
    local int i;

    for (i=0; i<30; i++)
    {
        if (GameList[i] == "" && i > 0)
            break;
        if (GameList[i] == sGame)
            return true;
    }
    return false;
}
function Tick (float DeltaTime)
{
	if ( (SelectionTime != 0) && (GetPlayerOwner().Level.TimeSeconds > SelectionTime + 1) )
	{
		if ( getSelectedItem() != None )
		{
		    if (bGameSelect)
		    {
		        if (GameMap == "")
		        {
		            Screenshot = NONE;
		            MapTitle = "";
		        }
		        else
		        {
		            SetMap(GameMap);
		        }
		    }
		    else
		    {
			   SetMap(MapVoteUMenuList(getSelectedItem()).MapName);
			}
			SelectionTime = 0.00;
		}
	}
	Super.Tick(DeltaTime);
}

function SetMap(string MapName)
{
	local int i;
	local LevelSummary L;
	local string RealMapName;

	bMapAlreadySet = True;

	i = InStr(Caps(MapName),".UNR");
	if ( i != -1 )
	{
		MapName=Left(MapName,i);
	}
	RealMapName = CheckMapname(MapName);
	Screenshot = Texture(DynamicLoadObject(RealMapName $ ".Screenshot",Class'Texture'));
	L = LevelSummary(DynamicLoadObject(RealMapName $ ".LevelSummary",Class'LevelSummary'));

	if ( Left(MapName,3) == "[X]" )
	{
		MapTitle = "Voting not Permitted";
		IdealPlayerCount="";
	}
	else
	{
		if ( L != None )
		{
			MapTitle = L.Title;
			IdealPlayerCount = L.IdealPlayerCount;
		}
		else
		{
			MapTitle = "DownLoad Required";
			IdealPlayerCount = "";
		}
	}
}

function string CheckMapname (string sMap)
{
	if ( Left(sMap,3) ~= "[X]" || Left(sMap,3) ~= "[G]")
	{
		sMap = Mid(sMap,3);
	}
	return sMap;
}

function Paint (Canvas C, float MouseX, float MouseY)
{

	Super.Paint(C,MouseX,MouseY);

	DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'grad1');

	C.DrawColor.R=0;
	C.DrawColor.G=0;
	C.DrawColor.B=64;

    DrawStretchedTexture(C, 20 + MapListwidth, 27, MapListwidth+5, 110, Texture'UnrealShare.NewBlue');

	if (  !bMapAlreadySet && (LogoTexture != "") && (Screenshot == None) )
	{
		Screenshot=Texture(DynamicLoadObject(LogoTexture,Class'Texture'));
		bMapAlreadySet=True;
	}
	if ( Screenshot != None )
	{
		C.DrawColor.R=128;
		C.DrawColor.G=128;
		C.DrawColor.B=128;
		DrawStretchedTexture(C,20 + MapListwidth,27.00,MapListwidth+5,110.00,Screenshot);
	}
	if ( MapTitle != "" )
	{
		lblMaptxt1.SetText(MapTitle);
	}
	else
	{
		lblMaptxt1.SetText("");
	}
    GameListBox.ThisGame = ThisGame;
}

function KeyDown (int Key, float X, float Y)  // 33=pgup 34=pgdn
{
    ParentWindow.KeyDown(Key,X,Y);
}

function Close (optional bool bByParent)
{
	local int W;
	local int Mode;

	Super.Close(bByParent);
}
//
