//================================================================================
// MapVoteWindowWelcome.
//================================================================================

class MapVoteWindowWelcome extends UWindowPageWindow;
//
#exec texture IMPORT NAME=mvxw File=Textures\mvxw1.pcx GROUP=Mapvote MIPS=OFF

var color WhiteColor, GrayColor;
var MapVoteSmallButton AnonButton;
var MapVoteSmallButton MailButton;
var MapVoteSmallButton BookButton;
var MapVoteSmallButton WebButton;

var string WebsiteURL;
var string ContactURL;

var string MenuLogoName;
var string MenuSoundName;
var bool   bStretch;

var Texture WelcomeLogo;
var Sound   WelcomeSound;

var bool bSoundDone;

var string Servername;
var string ServerPort;
var string ServerIP;

var string AnonButtonURL;

function Created ()
{
	Super.Created();


    MailButton=MapVoteSmallButton(CreateControl(Class'MapVoteSmallButton',15, 295, 110, 20));
    MailButton.DownSound=Sound'GlassTink1';
	MailButton.Text="Contact";
	MailButton.bDisabled=true;

    BookButton=MapVoteSmallButton(CreateControl(Class'MapVoteSmallButton',140, 275, 115, 20));
	BookButton.DownSound=Sound'GlassTink1';
	BookButton.Text="Add to Favorites";
	BookButton.bDisabled=True;

    AnonButton=MapVoteSmallButton(CreateControl(Class'MapVoteSmallButton',140, 295, 115, 20));
	AnonButton.DownSound=Sound'GlassTink1';
	AnonButton.Text="";
	AnonButton.bDisabled=True;

    WebButton=MapVoteSmallButton(CreateControl(Class'MapVoteSmallButton',270, 295, 110, 20));
    WebButton.DownSound=Sound'GlassTink1';
	WebButton.Text="Website";
	WebButton.bDisabled=true;

    SetAcceptsFocus();
}

function Notify (UWindowDialogControl C, byte E)
{
    local string sTemp;

    Super.Notify(C,E);

    Switch(E)
    {
	  case DE_Click:
	  switch(C)
      {
      case MailButton:
           if (MailButton.bDisabled == false)
           {
              sTemp = CheckMailAddress(ContactURL);
	          GetPlayerOwner().ConsoleCommand("start "$sTemp);
              ParentWindow.ParentWindow.Close();
           }
           break;
      case BookButton:
           if (MailButton.bDisabled == false)
              AddToFavourites();
           break;
      case WebButton:
           if (WebButton.bDisabled == false)
           {
              sTemp = CheckWebsiteURL(WebsiteURL);
              GetPlayerOwner().ConsoleCommand("start "$sTemp);
              ParentWindow.ParentWindow.Close();
           }
           break;
      case AnonButton:
           if (AnonButton.bDisabled == false)
           {
              sTemp = AnonButtonURL;
              GetPlayerOwner().ConsoleCommand("start "$sTemp);
              ParentWindow.ParentWindow.Close();
           }
           break;
      }
      break;
    }
}

simulated function AddToFavourites()
{
	local int i, j, k;

    j = class'UBrowserFavoritesFact'.default.FavoriteCount;
    if (j >= 99)
    {
        GetPlayerOwner().ClientMessage("Your UT Favourites is currently Full!");
        return;
    }

	for (i=0; i<j; i++) // check to see if already in favs
	{
		k = Instr(class'UBrowserFavoritesFact'.default.Favorites[i],"\\"$ServerIP$"\\"$ServerPort);
		if (k >= 0)
		{
		    GetPlayerOwner().ClientMessage("This server is already in your UT Favourites");
		    return;
	    }
	}

	class'UBrowserFavoritesFact'.default.Favorites[j] = ServerName$"\\"$ServerIP$"\\"$ServerPort$"\\False";
	class'UBrowserFavoritesFact'.default.FavoriteCount = j + 1;
	class'UBrowserFavoritesFact'.SaveConfig();
	class'UBrowserFavoritesFact'.static.StaticSaveConfig();
	GetPlayerOwner().ClientMessage("This server has been added to your UT Favourites");
}

function string CheckMailAddress(string sMail)
{
    local string sTemp;
    local int i;

    i = InStr(Caps(sMail), "MAILTO:");
    if (i > 0)
        return sMail;
    else
    if (Left(sMail, 3) ~= "www")
        return "http://"$sMail;
    else
    if (Left(sMail, 4) ~= "http")
        return sMail;
    else
        return "mailto:"$sMail;
}

function string CheckWebsiteURL(string WebURL)
{
    local string sTemp;
    local int i;

    if (Left(WebURL, 7) ~= "http://")
        return WebURL;
    i = InStr(WebURL, "://");   // ftp:// ? or unreal:// ?
    if (i > 0)
        return WebURL;
    else
        return "http://"$WebURL;
}

function Paint (Canvas C, float MouseX, float MouseY)
{
	Super.Paint(C,MouseX,MouseY);

    C.DrawColor  = WhiteColor;

    DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'BlackTexture');   // grad1

    if (WelcomeLogo == None && InStr(MenuLogoName, ".") > 0)
        WelcomeLogo = Texture(DynamicLoadObject(MenuLogoName, class'Texture'));

    if (WelcomeLogo != None)
    {   if (bStretch)
           DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,WelcomeLogo);
        else
        {
           C.SetPos(70, 25);
           if (WelcomeLogo.USize<= 256)
               C.DrawIcon( WelcomeLogo,  1.0 );
           else
               C.DrawIcon( Texture'mvxw',1.0 );
        }
    }
    else
    {
        C.SetPos(70, 25);
        C.DrawIcon( Texture'mvxw', 1.0 );
    }

    if (WelcomeSound == None && InStr(MenuSoundName, ".") > 0)
        WelcomeSound = Sound(DynamicLoadObject(MenuSoundName, class'Sound'));

    if (WelcomeSound != None && !bSoundDone)
    {
        bSoundDone = true;
        GetPlayerOwner().PlaySound(WelcomeSound);
    }
}

function Close (optional bool bByParent)
{
	Super.Close(bByParent);
}
//
defaultproperties
{
    WhiteColor=(R=255,G=255,B=255)
}
